﻿using System;
using System.Activities;

// activities to be used for waiting for events in the StateMachine
namespace StateMachine
{
    public class WaitForBookmark : NativeActivity
    {
        public InArgument<string> BookmarkName { get; set; }

        protected override bool CanInduceIdle
        {
            get { return true; }
        }

        protected override void Execute(NativeActivityContext context)
        {
            context.CreateBookmark(this.BookmarkName.Get(context));
        }
    }

    public class WriteLineWithColor: CodeActivity
    {
        public InArgument<string> Text { get; set; }

        public InArgument<ConsoleColor> Color { get; set; }

        protected override void Execute(CodeActivityContext context)
        {
            ConsoleColor previous = Console.ForegroundColor;
            Console.ForegroundColor = this.Color.Get(context);
            Console.WriteLine(this.Text.Get(context));
            Console.ForegroundColor = previous;
        }
    }
}
