﻿using System;
using System.Activities;
using System.Threading;

namespace StateMachine
{
    class Program
    {        
        static void Main(string[] args)
        {
            bool done = false;
            AutoResetEvent syncEvent = new AutoResetEvent(false);
            Activity definition = new StopwatchWorkflow();
            WorkflowApplication app = new WorkflowApplication(definition);
            app.Completed += (e) =>
                {
                    Console.WriteLine("Workflow completed");
                    done = true;
                    syncEvent.Set();                                        
                };
            app.Idle = (e) => syncEvent.Set();
            app.Run();
            syncEvent.WaitOne();
            
            while (!done)
            {
                Console.Write("        Transition? ");
                string option = Console.ReadLine();

                app.ResumeBookmark(option, option);
                syncEvent.WaitOne(TimeSpan.FromMilliseconds(400));
            }            
        }
    }
}
